// Copyright (c) FIRST and other WPILib contributors.
// Open Source Software; you can modify and/or share it under the terms of
// the WPILib BSD license file in the root directory of this project.

package frc.robot;

import edu.wpi.first.wpilibj.GenericHID;
import edu.wpi.first.wpilibj.XboxController;

import edu.wpi.first.wpilibj2.command.Command;
import edu.wpi.first.wpilibj2.command.RunCommand;
import frc.robot.commands.ActiverBlockeur;
import frc.robot.commands.Activer_poussoir;
import frc.robot.commands.Activershaker;
import frc.robot.commands.DesactiverBlockeur;
import frc.robot.subsystems.BasePilotable;
import frc.robot.subsystems.Pistonshaker;
import frc.robot.subsystems.Poussoir;

/**
 * This class is where the bulk of the robot should be declared. Since Command-based is a
 * "declarative" paradigm, very little robot logic should actually be handled in the {@link Robot}
 * periodic methods (other than the scheduler calls). Instead, the structure of the robot (including
 * subsystems, commands, and button mappings) should be declared here.
 */
public class RobotContainer {
  // The robot's subsystems and commands are defined here...
  XboxController manette = new XboxController(0);
  
  BasePilotable basePilotable = new BasePilotable();
  
  private Pistonshaker pistonshaker = new Pistonshaker();
  private Poussoir poussoir = new Poussoir();
  
  private Activer_poussoir activer_poussoir = new Activer_poussoir(poussoir);
  private ActiverBlockeur activerBlockeur = new ActiverBlockeur(poussoir);
  private Activershaker activershaker = new Activershaker(pistonshaker);
  private DesactiverBlockeur desactiverBlockeur = new DesactiverBlockeur(poussoir);
  /** The container for the robot. Contains subsystems, OI devices, and commands. */
  public RobotContainer() {
    // Configure the button bindings
    configureButtonBindings();

    basePilotable.setDefaultCommand(
      new RunCommand(
        ()-> basePilotable.drive(manette.getLeftY(), manette.getLeftX(), manette.getLeftTriggerAxis()-manette.getRightTriggerAxis()), basePilotable)
    );
  }

  /**
   * Use this method to define your button->command mappings. Buttons can be created by
   * instantiating a {@link GenericHID} or one of its subclasses ({@link
   * edu.wpi.first.wpilibj.Joystick} or {@link XboxController}), and then passing it to a {@link
   * edu.wpi.first.wpilibj2.command.button.JoystickButton}.
   */
  private void configureButtonBindings() {}

  /**
   * Use this to pass the autonomous command to the main {@link Robot} class.
   *
   * @return the command to run in autonomous
   */
  public Command getAutonomousCommand() {
    // An ExampleCommand will run in autonomous
    return null;
  }
}
